chiark / gitweb /
Replace getsig.java with a pure python implementation
[fdroidserver.git] / tests / run-tests
1 #!/bin/bash
2
3 set -e # quit script on error
4 set -x # show each command as it is executed
5
6 echo_header() {
7     echo "=============================================================================="
8     echo $1
9 }
10
11 copy_apks_into_repo() {
12     set +x
13     for f in `find $APKDIR -name '*.apk' | grep -F -v -e unaligned -e unsigned`; do
14         name=$(basename $(dirname `dirname $f`))
15         apk=`$aapt dump badging "$f" | sed -n "s,^package: name='\(.*\)' versionCode='\([0-9][0-9]*\)' .*,\1_\2.apk,p"`
16         test $f -nt repo/$apk && rm -f repo/$apk  # delete existing if $f is newer
17         if [ ! -e repo/$apk ] && [ ! -e archive/$apk ]; then
18             echo "$f --> repo/$apk"
19             ln $f $1/repo/$apk || \
20                 rsync -axv $f $1/repo/$apk # rsync if hard link is not possible
21         fi
22     done
23     set -x
24 }
25
26 # keep this as an old version to test the automatic parsing of build-tools
27 # verion numbers in `fdroid init`
28 create_fake_android_home() {
29     mkdir $1/tools
30     mkdir $1/platform-tools
31     mkdir $1/build-tools
32     mkdir $1/build-tools/19.0.2
33     touch $1/build-tools/19.0.2/aapt
34 }
35
36 create_test_dir() {
37     test -e $WORKSPACE/.testfiles || mkdir $WORKSPACE/.testfiles
38     mktemp --directory --tmpdir=$WORKSPACE/.testfiles
39 }
40
41 create_test_file() {
42     test -e $WORKSPACE/.testfiles || mkdir $WORKSPACE/.testfiles
43     mktemp --tmpdir=$WORKSPACE/.testfiles
44 }
45
46 #------------------------------------------------------------------------------#
47 # "main"
48
49 if [ $1 = "-h" ] || [ $1 = "--help" ]; then
50     set +x
51     echo "Usage: $0 '/path/to/folder/with/apks'"
52     exit 1
53 fi
54
55 if [ -z $ANDROID_HOME ]; then
56     echo "ANDROID_HOME must be set with the path to the Android SDK, i.e.: "
57     echo "  export ANDROID_HOME=/opt/android-sdk"
58     exit 1
59 fi
60
61 if [ -z $1 ]; then
62     APKDIR=`pwd`
63 else
64     APKDIR=$1
65 fi
66
67 if [ -z $WORKSPACE ]; then
68     WORKSPACE=`dirname $(pwd)`
69     echo "Setting Workspace to $WORKSPACE"
70 fi
71
72 # allow the location of the script to be overridden
73 if [ -z $fdroid ]; then
74     fdroid="$WORKSPACE/fdroid"
75 fi
76
77 # allow the location of aapt to be overridden
78 if [ -z $aapt ]; then
79     aapt=`ls -1 $ANDROID_HOME/build-tools/*/aapt | sort | tail -1`
80 fi
81
82 # allow the location of python to be overridden
83 if [ -z $python ]; then
84     python=python2
85 fi
86
87
88 #------------------------------------------------------------------------------#
89 echo_header "run commit hooks"
90
91 cd $WORKSPACE
92 ./hooks/pre-commit
93
94
95 #------------------------------------------------------------------------------#
96 echo_header "create a source tarball and use that to build a repo"
97
98 cd $WORKSPACE
99 $python setup.py sdist
100
101 REPOROOT=`create_test_dir`
102 cd $REPOROOT
103 tar xzf `ls -1 $WORKSPACE/dist/fdroidserver-*.tar.gz | sort -n | tail -1`
104 cd $REPOROOT
105 ./fdroidserver-*/fdroid init
106 copy_apks_into_repo $REPOROOT
107 ./fdroidserver-*/fdroid update --create-metadata
108
109
110 #------------------------------------------------------------------------------#
111 echo_header "test config checks of local_copy_dir"
112
113 REPOROOT=`create_test_dir`
114 cd $REPOROOT
115 $fdroid init
116 $fdroid update --create-metadata
117 $fdroid server update --local-copy-dir=/tmp/fdroid
118
119 # now test the errors work
120 set +e
121 $fdroid server update --local-copy-dir=thisisnotanabsolutepath
122 if [ $? -eq 0 ]; then
123     echo "This should have failed because thisisnotanabsolutepath is not an absolute path!"
124     exit 1
125 else
126     echo "testing absolute path checker passed"
127 fi
128 $fdroid server update --local-copy-dir=/tmp/IReallyDoubtThisPathExistsasdfasdf
129 if [ $? -eq 0 ]; then
130     echo "This should have failed because the path does not end with 'fdroid'!"
131     exit 1
132 else
133     echo "testing dirname exists checker passed"
134 fi
135 $fdroid server update --local-copy-dir=/tmp/IReallyDoubtThisPathExistsasdfasdf/fdroid
136 if [ $? -eq 0 ]; then
137     echo "This should have failed because the dirname path does not exist!"
138     exit 1
139 else
140     echo "testing dirname exists checker passed"
141 fi
142 set -e
143
144
145 #------------------------------------------------------------------------------#
146 echo_header "setup a new repo from scratch using ANDROID_HOME and do a local sync"
147
148 REPOROOT=`create_test_dir`
149 cd $REPOROOT
150 $fdroid init
151 copy_apks_into_repo $REPOROOT
152 $fdroid update --create-metadata
153 grep -F '<application id=' repo/index.xml
154
155 LOCALCOPYDIR=`create_test_dir`/fdroid
156 $fdroid server update --local-copy-dir=$LOCALCOPYDIR
157 NEWREPOROOT=`create_test_dir`
158 cd $NEWREPOROOT
159 $fdroid init
160 $fdroid server update --local-copy-dir=$LOCALCOPYDIR --sync-from-local-copy-dir
161
162
163 #------------------------------------------------------------------------------#
164 # check that --android-home fails when dir does not exist or is not a dir
165
166 REPOROOT=`create_test_dir`
167 KEYSTORE=$REPOROOT/keystore.jks
168 cd $REPOROOT
169 set +e
170 $fdroid init --keystore $KEYSTORE --android-home /opt/fakeandroidhome
171 if [ $? -eq 0 ]; then
172     echo "This should have failed because /opt/fakeandroidhome does not exist!"
173     exit 1
174 else
175     echo "testing android-home path checker passed"
176 fi
177 TESTFILE=`create_test_file`
178 $fdroid init --keystore $KEYSTORE --android-home $TESTFILE
179 if [ $? -eq 0 ]; then
180     echo "This should have failed because $TESTFILE is a file not a dir!"
181     exit 1
182 else
183     echo "testing android-home not-dir checker passed"
184 fi
185 set -e
186
187
188 #------------------------------------------------------------------------------#
189 echo_header "check that fake android home passes 'fdroid init'"
190
191 REPOROOT=`create_test_dir`
192 FAKE_ANDROID_HOME=`create_test_dir`
193 create_fake_android_home $FAKE_ANDROID_HOME
194 KEYSTORE=$REPOROOT/keystore.jks
195 cd $REPOROOT
196 $fdroid init --keystore $KEYSTORE --android-home $FAKE_ANDROID_HOME
197
198
199 #------------------------------------------------------------------------------#
200 echo_header "check that 'fdroid init' fails when build-tools cannot be found"
201
202 REPOROOT=`create_test_dir`
203 FAKE_ANDROID_HOME=`create_test_dir`
204 create_fake_android_home $FAKE_ANDROID_HOME
205 rm -f $FAKE_ANDROID_HOME/build-tools/*/aapt
206 KEYSTORE=$REPOROOT/keystore.jks
207 cd $REPOROOT
208 set +e
209 $fdroid init --keystore $KEYSTORE --android-home $FAKE_ANDROID_HOME
210 [ $? -eq 0 ] && exit 1
211 set -e
212
213
214 #------------------------------------------------------------------------------#
215 echo_header "check that --android-home overrides ANDROID_HOME"
216
217 REPOROOT=`create_test_dir`
218 FAKE_ANDROID_HOME=`create_test_dir`
219 create_fake_android_home $FAKE_ANDROID_HOME
220 KEYSTORE=$REPOROOT/keystore.jks
221 cd $REPOROOT
222 $fdroid init --keystore $KEYSTORE --android-home $FAKE_ANDROID_HOME
223 set +e
224 grep $FAKE_ANDROID_HOME $REPOROOT/config.py
225 if [ $? -ne 0 ]; then
226     echo "the value set in --android-home '$FAKE_ANDROID_HOME' should override ANDROID_HOME '$ANDROID_HOME'"
227     exit 1
228 fi
229 set -e
230
231
232 #------------------------------------------------------------------------------#
233 # In this case, ANDROID_HOME is set to a fake, non-working version that will
234 # be detected by fdroid as an Android SDK install.  It should use the path set
235 # by --android-home over the one in ANDROID_HOME, therefore if it uses the one
236 # in ANDROID_HOME, it won't work because it is a fake one.  Only
237 # --android-home provides a working one.
238 echo_header "setup a new repo from scratch with keystore and android-home set on cmd line"
239
240 REPOROOT=`create_test_dir`
241 KEYSTORE=$REPOROOT/keystore.jks
242 FAKE_ANDROID_HOME=`create_test_dir`
243 create_fake_android_home $FAKE_ANDROID_HOME
244 STORED_ANDROID_HOME=$ANDROID_HOME
245 unset ANDROID_HOME
246 echo "ANDROID_HOME: $ANDROID_HOME"
247 cd $REPOROOT
248 $fdroid init --keystore $KEYSTORE --android-home $STORED_ANDROID_HOME --no-prompt
249 test -e $KEYSTORE
250 copy_apks_into_repo $REPOROOT
251 $fdroid update --create-metadata
252 grep -F '<application id=' repo/index.xml
253 test -e repo/index.xml
254 test -e repo/index.jar
255 export ANDROID_HOME=$STORED_ANDROID_HOME
256
257
258 #------------------------------------------------------------------------------#
259 echo_header "setup new repo from scratch using ANDROID_HOME, putting APKs in repo first"
260
261 REPOROOT=`create_test_dir`
262 cd $REPOROOT
263 mkdir repo
264 copy_apks_into_repo $REPOROOT
265 $fdroid init
266 $fdroid update --create-metadata
267 grep -F '<application id=' repo/index.xml
268
269
270 #------------------------------------------------------------------------------#
271 echo_header "setup a new repo from scratch and generate a keystore"
272
273 REPOROOT=`create_test_dir`
274 KEYSTORE=$REPOROOT/keystore.jks
275 cd $REPOROOT
276 $fdroid init --keystore $KEYSTORE
277 test -e $KEYSTORE
278 copy_apks_into_repo $REPOROOT
279 $fdroid update --create-metadata
280 test -e repo/index.xml
281 test -e repo/index.jar
282 grep -F '<application id=' repo/index.xml
283
284
285 #------------------------------------------------------------------------------#
286 echo_header "setup a new repo from scratch, generate a keystore, then add APK and update"
287
288 REPOROOT=`create_test_dir`
289 KEYSTORE=$REPOROOT/keystore.jks
290 cd $REPOROOT
291 $fdroid init --keystore $KEYSTORE
292 test -e $KEYSTORE
293 copy_apks_into_repo $REPOROOT
294 $fdroid update --create-metadata
295 test -e repo/index.xml
296 test -e repo/index.jar
297 grep -F '<application id=' repo/index.xml
298 cp $WORKSPACE/tests/urzip.apk $REPOROOT/
299 $fdroid update --create-metadata
300 test -e repo/index.xml
301 test -e repo/index.jar
302 grep -F '<application id=' repo/index.xml
303
304
305 #------------------------------------------------------------------------------#
306 echo_header "setup a new repo from scratch with a HSM/smartcard"
307
308 REPOROOT=`create_test_dir`
309 cd $REPOROOT
310 $fdroid init --keystore NONE
311 test -e opensc-fdroid.cfg
312 test ! -e NONE
313
314 rm -rf $WORKSPACE/fdroidserver.egg-info/
315
316 echo SUCCESS